#include "colors.inc"

#declare tub_inx = tubx/2-tubthick
#declare tub_inz = tubz/2-tubthick

#declare tub_inside = union {
	box { 	<(tub_inx-tubround),(tuby+1),(tub_inz-tubround)>, 
		<-(tub_inx-tubround),(tubthick+tubround),-(tub_inz-tubround)> }
	box { 
		<(tub_inx-tubround),(tuby+1),(tub_inz-tubround)>, 
		<-(tub_inx-tubround),(tubthick+tubround),(tub_inz)> 
	}
	box { 
		<(tub_inx-tubround),(tuby+1),-(tub_inz-tubround)>,
		<-(tub_inx-tubround),(tubthick+tubround),-(tub_inz)> 
	}
	box { 
		<-(tub_inx-tubround),(tuby+1),(tub_inz-tubround)>, 
		<-(tub_inx),(tubthick+tubround),-(tub_inz-tubround)> 
	}
	box { 
		<(tub_inx-tubround),(tuby+1),(tub_inz-tubround)>, 
		<(tub_inx),(tubthick+tubround),-(tub_inz-tubround)>
	} 
	box { 
		<(tub_inx-tubround),(tubthick+tubround),(tub_inz-tubround)>, 
		<-(tub_inx-tubround),(tubthick),-(tub_inz-tubround)> 
	} 
	cylinder { 
		<(tub_inx-tubround),(tubthick+tubround),(tub_inz-tubround)>, 
		<(tub_inx-tubround),(tubthick+tubround),-(tub_inz-tubround)>, 
		tubround 
	}
	cylinder { 
		<-(tub_inx-tubround),(tubthick+tubround),(tub_inz-tubround)>, 
		<-(tub_inx-tubround),(tubthick+tubround),-(tub_inz-tubround)>, 
		tubround 
	}
	cylinder { 
		<(tub_inx-tubround),(tubthick+tubround),(tub_inz-tubround)>, 
		<-(tub_inx-tubround),(tubthick+tubround),(tub_inz-tubround)>, 
		tubround 
	}
	cylinder { 
		<(tub_inx-tubround),(tubthick+tubround),-(tub_inz-tubround)>,
		<-(tub_inx-tubround),(tubthick+tubround),-(tub_inz-tubround)>,
		tubround 
	}
	cylinder { 
		<(tub_inx-tubround),(tubthick+tubround),(tub_inz-tubround)>, 
		<(tub_inx-tubround), (tuby+1),(tub_inz-tubround)>, tubround 
	} 
	cylinder { 
		<-(tub_inx-tubround),(tubthick+tubround),(tub_inz-tubround)>, 
		<-(tub_inx-tubround), (tuby+1),(tub_inz-tubround)>, tubround 
	} 
	cylinder { 
		<(tub_inx-tubround),(tubthick+tubround),-(tub_inz-tubround)>, 
		<(tub_inx-tubround), (tuby+1),-(tub_inz-tubround)>, tubround 
	} 
	cylinder { 
		<-(tub_inx-tubround),(tubthick+tubround),-(tub_inz-tubround)>, 
		<-(tub_inx-tubround), (tuby+1),-(tub_inz-tubround)>, tubround 
	} 
	sphere {
		<(tub_inx-tubround), (tubthick+tubround), (tub_inz-tubround)>,
		tubround 
	} 
	sphere {
		<-(tub_inx-tubround), (tubthick+tubround), (tub_inz-tubround)>,
		tubround 
	} 
	sphere { 
		<(tub_inx-tubround), (tubthick+tubround), -(tub_inz-tubround)>,
		tubround 
	} 
	sphere {
		<-(tub_inx-tubround),(tubthick+tubround), -(tub_inz-tubround)>,
		tubround 
	} 
}

#declare tub = difference {
	box { <tubx/2,tuby,tubz/2>, <-tubx/2,0,-tubz/2> }
	object { tub_inside } 
}

#declare rail1 = union { 
	box { 
		<tubx/2, tuby+railht, -tubz/2>,
		<-tubx/2,tuby,-(tub_inz-tubround)>
	}
	intersection {
		cylinder {
			<tubx/2,tuby,-(tub_inz-tubround)>,
			<-tubx/2,tuby,-(tub_inz-tubround)>,
			railht
		}
		plane { <0,1,0>, tuby inverse }
	} 
}		

#declare rail2 = union { 
	box { 
		<tubx/2, tuby+railht, tubz/2>,
		<-tubx/2,tuby,(tub_inz-tubround)> 
	}
	intersection {
		cylinder {
			<tubx/2,tuby,(tub_inz-tubround)>,
			<-tubx/2,tuby,(tub_inz-tubround)>,
			railht
		}
		plane { <0,1,0>, tuby inverse }
	} 
}

#declare rail3 = union {
	box { 
		<tubx/2, tuby+railht, (tub_inz-tubround)>,
		<(tub_inx-tubround), tuby, -(tub_inz-tubround)>
	}
	intersection {
		cylinder {
			<(tub_inx-tubround), tuby, (tub_inz-tubround)>,
			<(tub_inx-tubround), tuby, -(tub_inz-tubround)>,
			railht
		}
		plane { <0,1,0>, tuby inverse }
	} 
}

#declare rail4 = union {
	box { 
		<-tubx/2, tuby+railht, (tub_inz-tubround)>,
		<-(tub_inx-tubround),tuby,-(tub_inz-tubround)>
	}
	intersection {
		cylinder {
			<-(tub_inx-tubround), tuby, (tub_inz-tubround)>,
			<-(tub_inx-tubround), tuby, -(tub_inz-tubround)>,
			railht
		}
		plane { <0,1,0>, tuby inverse }
	} 
}


#declare tub_tex = texture {
	pigment { rgb <0.0, 0.65, 0.65 > }
	finish { 
		diffuse 0.35
		specular 1.0
		roughness 0.005 
	}
}

#declare tub_wood1 = color rgb <0.56,0.40,0.15> 
#declare tub_woodline1 = color rgb <0.45,0.30,0.15>
#declare tub_woodline2 = color rgb <0.35,0.28,0.05>

#declare rail_tex = texture {
	pigment {
		gradient x
//		triangle_wave
		color_map {
			[ 0, rgb <0.85,0.85,0.85> ]
			[ 0.15 rgb <0.65,0,0.65> ]
			[ 0.35 rgb <0.25,0,0.25>]
			[ 0.55 rgb <0.5,0,0.5> ]
			[ 0.75 rgb <0.25,0,0.25>]
			[ 1 rgb <0.125,0,0.125> ]
		}
		turbulence < 0.3,0.1, 0.5>
		octaves 3
		lambda 0.5
		scale <12,1,8>
	}
}
